#include <stdlib.mqh>

extern int    Magic           = 980370;
extern int    MACDFastEMA     = 12;
extern int    MACDSlowEMA     = 26;
extern int    FastOrdinaryEMA = 60;
extern int    SlowOrdinaryEMA = 200;
extern bool   AutoTakeProfit  = false;
extern int    TakeProfit      = 10;
//extern bool   AutoStopLoss    = false;
extern int    StopLoss        = 100;
extern double Lots            = 0.1;
//extern bool   MoneyManagement = false;
//extern int    UseFreeMargin   = 20;
//extern int    AccountType     = 1;
//extern int    Leverage        = 100;

int    i;
int    ticket;

int    SL;
int    slippage;

double FastC;
double FastP;
double SlowC;
double SlowP;
double FastOC;
double FastOP;
double SlowOC;
double SlowOP;

int start()
{
   FastC=iMA(NULL,0,MACDFastEMA,0,MODE_EMA,PRICE_CLOSE,0);
   FastP=iMA(NULL,0,MACDFastEMA,0,MODE_EMA,PRICE_CLOSE,1);

   SlowC=iMA(NULL,0,MACDSlowEMA,0,MODE_EMA,PRICE_CLOSE,0);
   SlowP=iMA(NULL,0,MACDSlowEMA,0,MODE_EMA,PRICE_CLOSE,1);

   FastOC=iMA(NULL,0,FastOrdinaryEMA,0,MODE_EMA,PRICE_CLOSE,0);
   FastOP=iMA(NULL,0,FastOrdinaryEMA,0,MODE_EMA,PRICE_CLOSE,1);

   SlowOC=iMA(NULL,0,SlowOrdinaryEMA,0,MODE_EMA,PRICE_CLOSE,0);
   SlowOP=iMA(NULL,0,SlowOrdinaryEMA,0,MODE_EMA,PRICE_CLOSE,1);

   if ((FastC>SlowC && FastP<SlowP) || (FastOC>SlowOC && FastOP<SlowOP))
   {
      // BUY
      if (AutoTakeProfit)
      {
         for(i=0;i<OrdersTotal();i++)   
         {
            OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
	    if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
	    {
               if (OrderType()==OP_SELL)
               {				
                  OrderClose(OrderTicket(),OrderLots(),Ask,slippage,CLR_NONE);
               }
              
               if (OrderType()==OP_BUY)
               {				
                  OrderClose(OrderTicket(),OrderLots(),Bid,slippage,CLR_NONE);
               }
            }
         } 
      }

      ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,Ask-SL*Point,(Ask+TakeProfit*Point)*AutoTakeProfit,"SAL MACd-Buy",Magic,Blue);
      if (ticket==-1)
      {
         Print("BUY ORDER FAILED: ",ErrorDescription(GetLastError()));
      }
   }

   if ((FastC<SlowC && FastP>SlowP) || (FastOC<SlowOC && FastOP>SlowOP))
   {
      // SELL
      if (AutoTakeProfit)
      {
         for(i=0;i<OrdersTotal();i++)   
         {
            OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
	    if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
	    {
               if (OrderType()==OP_SELL)
               {				
                  OrderClose(OrderTicket(),OrderLots(),Ask,slippage,CLR_NONE);
               }
              
               if (OrderType()==OP_BUY)
               {				
                  OrderClose(OrderTicket(),OrderLots(),Bid,slippage,CLR_NONE);
               }
            }
         } 
      }
   
      ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,Bid+SL*Point,(Bid-TakeProfit*Point)*AutoTakeProfit,"SAL MACd-Sell",Magic,Red);
      if (ticket==-1)
      {
         Print("SELL ORDER FAILED: ",ErrorDescription(GetLastError()));
      }
   }

   return(0);
}